unit uScrollboxOptionsTwo;

{******************************************************************************
Initial Author   :    Scott Price
Initially Created:    2003-10-20
Language         :    Object Pascal
Compiler Version :    Delphi 3.02, 4.03, 5.01, 6.02 (UK)
Copyright        :     Information Technology Sector Limited, 1996-2002

Source Code Constraints:
========================
   Distribution, disclosure or modifications of this source code, outside of
   any licenced agreements with Information Technology Sector Limited, or
   removal of this notice constitutes a breach of any or all license agreements.

Operating Systems Tested On:
============================
   Microsoft Windows(R) 98, First Edition
   Microsoft Windows(R) 2000, Service Pack 3

Design Notes:
=============

VERSION  AUTHOR                DATE/TIME
===============================================================================
$history$
$nokeywords$
===============================================================================
NOTES:
===============================================================================
TODO:
******************************************************************************}


interface



uses
  { Borland Standard Units }
  Classes, Forms, ExtCtrls, Controls, StdCtrls;


type
  { TUserInformation }

  TUserInformation = record
    ssFirstName: ShortString;
    ssMiddleNames: ShortString;
    ssLastName: ShortString;
    s10Gender: String[10];
    pcAddress: PChar;
  end;

  { TOptionsTwo }

  TOptionsTwo = class(TScrollBox)
  private
    { Private Declarations }
    RadioGroup1: TRadioGroup;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lbOptionsTwoGroupTwoGender: TLabel;
    lbAddressNameNo: TLabel;
    lbAddressTown: TLabel;
    lbAddressRegion: TLabel;
    lbAddressPostalCode: TLabel;
    edOptionTwoFirstName: TEdit;
    edOptionTwoMiddleNames: TEdit;
    edOptionTwoLastName: TEdit;
    cbxOptionsTwoGender: TComboBox;
    btnCheckElectoralRegister: TButton;
    AddressNameNo: TEdit;
    AddressRoad: TEdit;
    AddressTownCity: TEdit;
    AddressRegion: TEdit;
    AddressPostalCode: TEdit;
    btnValidateAddressInfo: TButton;
    btnDoSomethingAgainstAddress: TButton;
    FUserInfo: TUserInformation;
    function CheckUserAlreadyAgainstAddress(
      User: TUserInformation): Boolean;
  protected
    { Protected Declarations }
    procedure btnCheckElectoralRegisterClick(Sender: TObject);
    procedure btnDoSomethingAgainstAddressClick(Sender: TObject);
    function CheckUserExistsOnElectoralRegister: Boolean;
    function CheckWeHaveRequiredDataFields: Boolean;
    function CheckUserMarkedAtAddress: Boolean;
    procedure InsertUserAgainstAddress;
    function GetElectoralRegisterDataForUser(
      User: TUserInformation): Boolean;
  public
    { Public Declarations }
    constructor Create(AOwner: TComponent; Parent: TWinControl); overload;
    property UserInformation: TUserInformation read FUserInfo;
  published
    { Published Declarations }
  end;


implementation



uses
  { Borland Standard Units }
  SysUtils, Dialogs;


  { TOptionsTwo }

constructor TOptionsTwo.Create(AOwner: TComponent; Parent: TWinControl);
begin
  Create(AOwner);

  RadioGroup1 := TRadioGroup.Create(Self);
  GroupBox1 := TGroupBox.Create(Self);
  Label1 := TLabel.Create(Self);
  Label2 := TLabel.Create(Self);
  Label3 := TLabel.Create(Self);
  lbOptionsTwoGroupTwoGender := TLabel.Create(Self);
  lbAddressNameNo := TLabel.Create(Self);
  lbAddressTown := TLabel.Create(Self);
  lbAddressRegion := TLabel.Create(Self);
  lbAddressPostalCode := TLabel.Create(Self);
  edOptionTwoFirstName := TEdit.Create(Self);
  edOptionTwoMiddleNames := TEdit.Create(Self);
  edOptionTwoLastName := TEdit.Create(Self);
  cbxOptionsTwoGender := TComboBox.Create(Self);
  btnCheckElectoralRegister := TButton.Create(Self);
  AddressNameNo := TEdit.Create(Self);
  AddressRoad := TEdit.Create(Self);
  AddressTownCity := TEdit.Create(Self);
  AddressRegion := TEdit.Create(Self);
  AddressPostalCode := TEdit.Create(Self);
  btnValidateAddressInfo := TButton.Create(Self);
  btnDoSomethingAgainstAddress := TButton.Create(Self);

  Self.Parent := Parent;
  Align := alClient;
  TabOrder := 0;

  with RadioGroup1 do
  begin
    Name := 'RadioGroup1';
    Parent := Self;
    Left := 12;
    Top := 16;
    Width := 293;
    Height := 89;
    Caption := ' Selects Two ';
    Items.Add('Another Option Item 1');
    Items.Add('Another Option Item 2');
    TabOrder := 0;
  end;
  with GroupBox1 do
  begin
    Name := 'GroupBox1';
    Parent := Self;
    Left := 12;
    Top := 116;
    Width := 329;
    Height := 285;
    Caption := ' Group Two ';
    TabOrder := 1;
  end;
  with Label1 do
  begin
    Name := 'Label1';
    Parent := GroupBox1;
    Left := 54;
    Top := 27;
    Width := 50;
    Height := 13;
    Alignment := taRightJustify;
    Caption := 'First Name';
  end;
  with Label2 do
  begin
    Name := 'Label2';
    Parent := GroupBox1;
    Left := 37;
    Top := 51;
    Width := 67;
    Height := 13;
    Alignment := taRightJustify;
    Caption := 'Middle Names';
  end;
  with Label3 do
  begin
    Name := 'Label3';
    Parent := GroupBox1;
    Left := 53;
    Top := 75;
    Width := 51;
    Height := 13;
    Alignment := taRightJustify;
    Caption := 'Last Name';
  end;
  with lbOptionsTwoGroupTwoGender do
  begin
    Name := 'lbOptionsTwoGroupTwoGender';
    Parent := GroupBox1;
    Left := 69;
    Top := 100;
    Width := 35;
    Height := 13;
    Alignment := taRightJustify;
    Caption := 'Gender';
  end;
  with lbAddressNameNo do
  begin
    Name := 'lbAddressNameNo';
    Parent := GroupBox1;
    Left := 16;
    Top := 155;
    Width := 88;
    Height := 13;
    Alignment := taRightJustify;
    Caption := 'Address Name/No';
  end;
  with lbAddressTown do
  begin
    Name := 'lbAddressTown';
    Parent := GroupBox1;
    Left := 77;
    Top := 203;
    Width := 27;
    Height := 13;
    Alignment := taRightJustify;
    Caption := 'Town';
  end;
  with lbAddressRegion do
  begin
    Name := 'lbAddressRegion';
    Parent := GroupBox1;
    Left := 70;
    Top := 227;
    Width := 34;
    Height := 13;
    Alignment := taRightJustify;
    Caption := 'Region';
  end;
  with lbAddressPostalCode do
  begin
    Name := 'lbAddressPostalCode';
    Parent := GroupBox1;
    Left := 48;
    Top := 252;
    Width := 57;
    Height := 13;
    Alignment := taRightJustify;
    Caption := 'Postal Code';
  end;
  with edOptionTwoFirstName do
  begin
    Name := 'edOptionTwoFirstName';
    Parent := GroupBox1;
    Left := 112;
    Top := 24;
    Width := 197;
    Height := 21;
    TabOrder := 0;
    Text := 'Susan';
  end;
  with edOptionTwoMiddleNames do
  begin
    Name := 'edOptionTwoMiddleNames';
    Parent := GroupBox1;
    Left := 112;
    Top := 48;
    Width := 197;
    Height := 21;
    TabOrder := 1;
  end;
  with edOptionTwoLastName do
  begin
    Name := 'edOptionTwoLastName';
    Parent := GroupBox1;
    Left := 112;
    Top := 72;
    Width := 197;
    Height := 21;
    TabOrder := 2;
    Text := 'Brown';
  end;
  with cbxOptionsTwoGender do
  begin
    Name := 'cbxOptionsTwoGender';
    Parent := GroupBox1;
    Left := 112;
    Top := 96;
    Width := 197;
    Height := 21;
    ItemHeight := 13;
    ItemIndex := 0;
    TabOrder := 3;
    Text := 'Female';
    Items.Add('Female');
    Items.Add('Male');
  end;
  with btnCheckElectoralRegister do
  begin
    Name := 'btnCheckElectoralRegister';
    Parent := GroupBox1;
    Left := 172;
    Top := 120;
    Width := 143;
    Height := 25;
    Caption := 'Check Electoral Register';
    TabOrder := 4;
    OnClick := btnCheckElectoralRegisterClick;
  end;
  with AddressNameNo do
  begin
    Name := 'AddressNameNo';
    Parent := GroupBox1;
    Left := 112;
    Top := 152;
    Width := 197;
    Height := 21;
    TabOrder := 5;
    Text := 'Address Name/No';
  end;
  with AddressRoad do
  begin
    Name := 'AddressRoad';
    Parent := GroupBox1;
    Left := 112;
    Top := 176;
    Width := 197;
    Height := 21;
    TabOrder := 6;
    Text := 'Address Road';
  end;
  with AddressTownCity do
  begin
    Name := 'AddressTownCity';
    Parent := GroupBox1;
    Left := 112;
    Top := 200;
    Width := 197;
    Height := 21;
    TabOrder := 7;
    Text := 'Address Town/City';
  end;
  with AddressRegion do
  begin
    Name := 'AddressRegion';
    Parent := GroupBox1;
    Left := 112;
    Top := 224;
    Width := 197;
    Height := 21;
    TabOrder := 8;
    Text := 'Address Region';
  end;
  with AddressPostalCode do
  begin
    Name := 'AddressPostalCode';
    Parent := GroupBox1;
    Left := 112;
    Top := 248;
    Width := 109;
    Height := 21;
    TabOrder := 9;
    Text := 'Address Postal Code';
  end;
  with btnValidateAddressInfo do
  begin
    Name := 'btnValidateAddressInfo';
    Parent := Self;
    Left := 188;
    Top := 388;
    Width := 153;
    Height := 25;
    Caption := 'Validate Address Info';
    TabOrder := 2;
  end;
  with btnDoSomethingAgainstAddress do
  begin
    Name := 'btnDoSomethingAgainstAddress';
    Parent := Self;
    Left := 16;
    Top := 388;
    Width := 169;
    Height := 25;
    Caption := 'Do Something Against Address';
    TabOrder := 3;
    OnClick := btnDoSomethingAgainstAddressClick;
  end;
end;

procedure TOptionsTwo.btnCheckElectoralRegisterClick(Sender: TObject);
begin
  { We need to know if the user is valid if at all possible in advance }
  if CheckWeHaveRequiredDataFields then
  begin
    if CheckUserExistsOnElectoralRegister then
    begin

    end else
      raise Exception.Create('Check with user why not on electoral register');
  end else
    ShowMessage('Please Fill in the required fields to proceed');
end;

procedure TOptionsTwo.btnDoSomethingAgainstAddressClick(
  Sender: TObject);
begin
  { Check our DB records for the user listed at that address, if not then add }
  if NOT CheckUserMarkedAtAddress then
    InsertUserAgainstAddress;
end;

function TOptionsTwo.CheckWeHaveRequiredDataFields: Boolean;
begin
  { Checking the fields aren't blank in the data we were given etc }
  Result := False;

  if edOptionTwoFirstName.Text = '' then
  begin
    ShowMessage('Must provide a first name!');
    Exit;
  end;

  if edOptionTwoLastName.Text = '' then
  begin
    ShowMessage('Must provide a last name!');
    Exit;
  end;

  Result := True;
end;

function TOptionsTwo.CheckUserExistsOnElectoralRegister: Boolean;
begin
  { Go On, check the user is at the address or something }
  Result := GetElectoralRegisterDataForUser(FUserInfo);
end;

function TOptionsTwo.CheckUserMarkedAtAddress: Boolean;
begin
  { Go On, check the user is marked against the address already }
  Result := CheckUserAlreadyAgainstAddress(FUserInfo);
end;

procedure TOptionsTwo.InsertUserAgainstAddress;
begin
  { Baahhhh, go do all that data work :) }
end;

function TOptionsTwo.GetElectoralRegisterDataForUser(
  User: TUserInformation): Boolean;
begin
  { Do what ever work to get a result back }
end;

function TOptionsTwo.CheckUserAlreadyAgainstAddress(
  User: TUserInformation): Boolean;
begin
  { Do what ever work to get a result back }
end;

end.
