unit uBlobMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Grids, DBGrids, DB;


type
  TUserInformation = record
    ssFirstName: ShortString;
    ssMiddleNames: ShortString;
    ssLastName: ShortString;
    s10Gender: String[10];
    pcAddress: PChar;
  end;

type
  TfmSimpleBlobExample = class(TForm)
    pcOptions: TPageControl;
    tsOptionsOne: TTabSheet;
    tsOptionsTwo: TTabSheet;
    tsOptionsThree: TTabSheet;
    sbxOptionsThree: TScrollBox;
    sbxOptionsTwo: TScrollBox;
    sbxOptionsOne: TScrollBox;
    rgSelectsOptionOne: TRadioGroup;
    gpGroupOptionOne: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    ComboBox1: TComboBox;
    lbGroupOptionsOneEdit1: TLabel;
    lbGroupOptionsOneEdit2: TLabel;
    lbGroupOptionsOneComboBox1: TLabel;
    RadioGroup1: TRadioGroup;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    edOptionTwoFirstName: TEdit;
    edOptionTwoMiddleNames: TEdit;
    RadioGroup2: TRadioGroup;
    edOptionTwoLastName: TEdit;
    Label3: TLabel;
    lbOptionsTwoGroupTwoGender: TLabel;
    cbxOptionsTwoGender: TComboBox;
    btnCheckElectoralRegister: TButton;
    lbAddressNameNo: TLabel;
    AddressNameNo: TEdit;
    AddressRoad: TEdit;
    AddressTownCity: TEdit;
    AddressRegion: TEdit;
    AddressPostalCode: TEdit;
    lbAddressTown: TLabel;
    lbAddressRegion: TLabel;
    lbAddressPostalCode: TLabel;
    btnValidateAddressInfo: TButton;
    btnDoSomethingAgainstAddress: TButton;
    DBGrid1: TDBGrid;
    btnCheckOrderStock: TButton;
    btnConfirnAndCreateOrder: TButton;
    btnDispatchOrderToCustomer: TButton;
    procedure btnCheckElectoralRegisterClick(Sender: TObject);
    procedure btnDoSomethingAgainstAddressClick(Sender: TObject);
    procedure btnCheckOrderStockClick(Sender: TObject);
    procedure btnConfirnAndCreateOrderClick(Sender: TObject);
    procedure btnDispatchOrderToCustomerClick(Sender: TObject);
  private
    { Private declarations }
    function CheckWeHaveRequiredDataFields: Boolean;
    function CheckUserExistsOnElectoralRegister: Boolean;
    function CheckUserMarkedAtAddress: Boolean;
    procedure InsertUserAgainstAddress;
    procedure GetUserInformation(var User: TUserInformation);
    function CheckUserAlreadyAgainstAddress(User: TUserInformation): Boolean;
    function GetElectoralRegisterDataForUser(User: TUserInformation): Boolean;
  public
    { Public declarations }
  end;

var
  fmSimpleBlobExample: TfmSimpleBlobExample;

implementation

{$R *.dfm}

procedure TfmSimpleBlobExample.btnCheckElectoralRegisterClick(
  Sender: TObject);
begin
  { We need to know if the user is valid if at all possible in advance }
  if CheckWeHaveRequiredDataFields then
  begin
    if CheckUserExistsOnElectoralRegister then
    begin

    end else
      raise Exception.Create('Check with user why not on electoral register');
  end else
    ShowMessage('Please Fill in the required fields to proceed');
end;

procedure TfmSimpleBlobExample.btnDoSomethingAgainstAddressClick(
  Sender: TObject);
begin
  { Check our DB records for the user listed at that address, if not then add }
  if NOT CheckUserMarkedAtAddress then
    InsertUserAgainstAddress;
end;

function TfmSimpleBlobExample.CheckUserMarkedAtAddress: Boolean;
var
  UserInfo: TUserInformation;
begin
  { Go On, check the user is marked against the address already }
  GetUserInformation(UserInfo);

  Result := CheckUserAlreadyAgainstAddress(UserInfo);
end;

function TfmSimpleBlobExample.CheckUserExistsOnElectoralRegister: Boolean;
var
  UserInfo: TUserInformation;
begin
  { Go On, check the user is at the address or something }
  GetUserInformation(UserInfo);

  Result := GetElectoralRegisterDataForUser(UserInfo);
end;

function TfmSimpleBlobExample.CheckWeHaveRequiredDataFields: Boolean;
begin
  { Checking the fields aren't blank in the data we were given etc }
  Result := False;

  if edOptionTwoFirstName.Text = '' then
  begin
    ShowMessage('Must provide a first name!');
    Exit;
  end;

  if edOptionTwoLastName.Text = '' then
  begin
    ShowMessage('Must provide a last name!');
    Exit;
  end;

  Result := True;
end;

procedure TfmSimpleBlobExample.GetUserInformation(
  var User: TUserInformation);
begin
  { Do the gathering of the user infomation into the record, etc }
end;

procedure TfmSimpleBlobExample.InsertUserAgainstAddress;
begin
  { Baahhhh, go do all that data work :) }
end;

function TfmSimpleBlobExample.CheckUserAlreadyAgainstAddress(
  User: TUserInformation): Boolean;
begin
  { Do what ever work to get a result back }
end;

function TfmSimpleBlobExample.GetElectoralRegisterDataForUser(
  User: TUserInformation): Boolean;
begin
  { Do what ever work to get a result back }
end;

procedure TfmSimpleBlobExample.btnCheckOrderStockClick(Sender: TObject);
var
  I, iRecords: Integer;
  dst: TDataSet;
begin
  if (DBGrid1.DataSource <> Nil) AND (DBGrid1.DataSource.DataSet <> Nil) then
  begin
    dst := DBGrid1.DataSource.DataSet;
    iRecords := dst.RecordCount - 1;

    dst.First;
    for I := 0 to iRecords do
    begin
      { Check the stock of item specified }

      if I < iRecords then
        dst.Next;
    end;
  end;
end;

procedure TfmSimpleBlobExample.btnConfirnAndCreateOrderClick(
  Sender: TObject);
begin
  { Place an order for that user for the items specified }
end;

procedure TfmSimpleBlobExample.btnDispatchOrderToCustomerClick(
  Sender: TObject);
begin
  { Dispatch the current completed order to the User }
end;

end.
